Imports System.Text

Public Class Form1
    ' Make the random words.
    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        txtStringTime.Clear()
        txtStringBuilderTime.Clear()
        Me.Cursor = Cursors.WaitCursor
        Refresh()

        Dim start_time, stop_time As Date
        Dim elapsed As TimeSpan

        ' Get the number of words and letters per word.
        Dim num_letters As Integer = Integer.Parse(txtNumLetters.Text)
        Dim num_words As Integer = Integer.Parse(txtNumWords.Text)

        ' Make an array of the letters we will use.
        Dim letters() As Char = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".ToCharArray()

        ' Make a random number generator.
        Dim rand As New Random()

        ' ********************
        ' Use &=.
        start_time = DateTime.Now

        ' Make the words.
        Dim words(num_words - 1) As String
        For i As Integer = 0 To num_words - 1
            ' Make a word.
            Dim word As String = ""
            For j As Integer = 1 To num_letters
                ' Pick a random number between 0 and 25
                ' to select a letter from the letters array.
                Dim letter_num As Integer = rand.Next(0, letters.Length - 1)

                ' Append the letter.
                word &= letters(letter_num)
            Next j

            ' Add the word to the list.
            words(i) = word
        Next i
        stop_time = DateTime.Now
        elapsed = stop_time - start_time
        txtStringTime.Text = elapsed.TotalSeconds.ToString("0.00") & " sec"
        Refresh()

        ' ********************
        ' Use StringBuilder.
        start_time = DateTime.Now

        ' Make the words.
        ReDim words(num_words - 1)
        For i As Integer = 0 To num_words - 1
            ' Make a word.
            Dim string_builder As New StringBuilder()
            For j As Integer = 1 To num_letters
                ' Pick a random number between 0 and 25
                ' to select a letter from the letters array.
                Dim letter_num As Integer = rand.Next(0, letters.Length - 1)

                ' Append the letter.
                string_builder.Append(letters(letter_num))
            Next j

            ' Add the word to the list.
            words(i) = string_builder.ToString()
        Next i
        stop_time = DateTime.Now
        elapsed = stop_time - start_time
        txtStringBuilderTime.Text = elapsed.TotalSeconds.ToString("0.00") & " sec"

        Me.Cursor = Cursors.Default
    End Sub
End Class
